function PCI_detect:boolean;
  var regs:TRmRegs;
  begin
    ClearRmRegs(regs);
    regs.ax:=$0B101;
    RealModeInt(PCI_INT,regs);
    PCI_detect:= ((regs.ah=0) AND (regs.edx=PCI_ID_STRING));
    PCI_ver:=regs.bx;  // store version in BCD format
  end;

function PCI_ReadConfigDWord(dev_num,bus_num,reg_num:word):dword;
  var regs:TRmRegs;
  begin
    ClearRmRegs(regs);
    regs.ax:=$0B10A;
    regs.bh:=bus_num;
    regs.bl:=dev_num;
    regs.di:=reg_num;
    RealModeInt(PCI_INT,regs);
    PCI_ReadConfigDWord:=regs.ecx;
  end;

procedure PCI_WriteConfigDWord(dev_num,bus_num,reg_num:word; _data:dword);
  var regs:TRmRegs;
  begin
    ClearRmRegs(regs);
    regs.ax:=$0B10D;
    regs.bh:=bus_num;
    regs.bl:=dev_num;
    regs.di:=reg_num;
    regs.ecx:=_data;
    RealModeInt(PCI_INT,regs);
  end;

function PCI_FindLFBSurface:dword;
  var i,j,tmp:dword;
      dev,bus:dword;
  begin
    for i:=0 to 511 do begin
        dev:=(i shl 3) AND $0F8;
        bus:=(i shr 5) and $0F;
        // read Vendor ID and Device ID
        tmp:=PCI_ReadConfigDWord(dev, bus, 0);
        // some broken devices return 0 if slot is empty
        if (tmp=0) OR (tmp=$0FFFFFFFF) then continue;
           // we have some device here...
           // store device vendor ID
           PCI_vendor:=tmp AND $0FFFF;
           // read device class
           tmp:=PCI_ReadConfigDWord(dev,bus,8) shr 16;
           if (tmp AND $0FFFF)=$300 then begin
              // device is VGA compatible. try to determine video surface
              // base address
              j:=0;
              tmp:=1; // set flag
              // search in configuration space for flat memory surface
              while (((tmp AND 1)<>0) AND (j<6)) do begin
                 // if bit 0 is set then the region is in I/O space else
                 // if clear then it is in memory space. (we need memory)
                 tmp:=PCI_ReadConfigDWord(dev,bus,$10+j*4);
                 j:=j+1;
              end;
              if (tmp<>0) AND ((tmp AND 1)=0) then begin
                 // if surface base is non-zero and it is memory space then
                 // return memory space (aligned on 256 bytes)
                 PCI_FindLFBSurface:=tmp AND $0FFFFFF00;
                 exit;
              end;
           end;
        end;
        PCI_FindLFBSurface:=0;
    end;
